package com.cecf.observe;

import io.opentelemetry.proto.collector.trace.v1.ExportTraceServiceRequest;
import org.apache.flink.api.common.serialization.DeserializationSchema;
import org.apache.flink.api.common.typeinfo.TypeHint;
import org.apache.flink.api.common.typeinfo.TypeInformation;
import org.apache.flink.api.common.typeinfo.Types;

import java.io.IOException;
import java.util.List;

public class ExportTraceServiceRequestSchema implements DeserializationSchema<List<PojoSpan>> {
    PbPojoConverter pbPojoConverter;

    public ExportTraceServiceRequestSchema() {
        pbPojoConverter = new PbPojoConverter();
    }

    @Override
    public List<PojoSpan> deserialize(byte[] bytes) throws IOException {
        return pbPojoConverter.pb2PojoSpanList(ExportTraceServiceRequest.parseFrom(bytes));
    }

    @Override
    public boolean isEndOfStream(List<PojoSpan> pojoSpans) {
        return false;
    }

    @Override
    public TypeInformation<List<PojoSpan>> getProducedType() {
        return Types.LIST(TypeInformation.of(PojoSpan.class));
    }
}
